%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                                         PSG Type    PSG Object                                Location in Problem Statement                            Class
%BGS                                            data        pmatrix_varpr                             pr_pen(parameter_Min_cov_served,pmatrix_varpr)           double
%pmatrix_varpr_vars                             vars        pmatrix_varpr                             pr_pen(parameter_Min_cov_served,pmatrix_varpr)           cell
%matrix_ss_data                                 data        matrix_ss                                 linear(matrix_ss)                                        double
%matrix_ss_vars                                 vars        matrix_ss                                 linear(matrix_ss)                                        cell
%Max_unserved_level                             data        parameter_Max_unserved_level              constraint: <= parameter_Max_unserved_level , mip = 1    double
%parameter_Min_cov_served_data                  data        parameter_Min_cov_served                  pr_pen(parameter_Min_cov_served,pmatrix_varpr)           double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = problem_Pr_in_constraint(BGS,pmatrix_varpr_vars,matrix_ss_data,matrix_ss_vars,Max_unserved_level,parameter_Min_cov_served_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = pmatrix_pack('pmatrix_varpr',BGS,pmatrix_varpr_vars);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_ss',matrix_ss_data,matrix_ss_vars,[],[]);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'problem_Cell_Towers_Pr, minimize',...
'  linear(matrix_ss)',...
'constraint: <= parameter_Max_unserved_level , mip = 1',...
'  pr_pen(parameter_Min_cov_served,pmatrix_varpr)',...
'box: types = 1',...
'solver: vangrb',...
' ',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_Max_unserved_level',num2str(Max_unserved_level));
problem_statement = strrep(problem_statement,'parameter_Min_cov_served',num2str(parameter_Min_cov_served_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

